-- ==============================================================
-- RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
-- Version: 2022.1
-- Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity cache_module is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    address : IN STD_LOGIC_VECTOR (31 downto 0);
    dirty : OUT STD_LOGIC;
    dirty_ap_vld : OUT STD_LOGIC;
    hit : OUT STD_LOGIC;
    hit_ap_vld : OUT STD_LOGIC;
    data : OUT STD_LOGIC_VECTOR (7 downto 0);
    data_ap_vld : OUT STD_LOGIC;
    updateSet : IN STD_LOGIC_VECTOR (7 downto 0);
    updateWay : IN STD_LOGIC_VECTOR (7 downto 0);
    newTag : IN STD_LOGIC_VECTOR (31 downto 0);
    updateTagValid : IN STD_LOGIC;
    newData_address0 : OUT STD_LOGIC_VECTOR (1 downto 0);
    newData_ce0 : OUT STD_LOGIC;
    newData_q0 : IN STD_LOGIC_VECTOR (7 downto 0);
    updateDataValid : IN STD_LOGIC );
end;


architecture behav of cache_module is 
    attribute CORE_GENERATION_INFO : STRING;
    attribute CORE_GENERATION_INFO of behav : architecture is
    "cache_module_cache_module,hls_ip_2022_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg400-1,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=6.917000,HLS_SYN_LAT=10,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=164,HLS_SYN_LUT=730,HLS_VERSION=2022_1}";
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_fsm_state1 : STD_LOGIC_VECTOR (7 downto 0) := "00000001";
    constant ap_ST_fsm_state2 : STD_LOGIC_VECTOR (7 downto 0) := "00000010";
    constant ap_ST_fsm_state3 : STD_LOGIC_VECTOR (7 downto 0) := "00000100";
    constant ap_ST_fsm_state4 : STD_LOGIC_VECTOR (7 downto 0) := "00001000";
    constant ap_ST_fsm_state5 : STD_LOGIC_VECTOR (7 downto 0) := "00010000";
    constant ap_ST_fsm_state6 : STD_LOGIC_VECTOR (7 downto 0) := "00100000";
    constant ap_ST_fsm_state7 : STD_LOGIC_VECTOR (7 downto 0) := "01000000";
    constant ap_ST_fsm_state8 : STD_LOGIC_VECTOR (7 downto 0) := "10000000";
    constant ap_const_lv32_0 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000000";
    constant ap_const_boolean_1 : BOOLEAN := true;
    constant ap_const_lv1_1 : STD_LOGIC_VECTOR (0 downto 0) := "1";
    constant ap_const_lv32_2 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000010";
    constant ap_const_lv32_3 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000011";
    constant ap_const_lv32_4 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000100";
    constant ap_const_lv32_6 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000110";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_const_lv32_7 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000111";
    constant ap_const_lv32_1 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000001";
    constant ap_const_lv8_0 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    constant ap_const_lv8_F : STD_LOGIC_VECTOR (7 downto 0) := "00001111";
    constant ap_const_lv32_5 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000101";
    constant ap_const_lv3_0 : STD_LOGIC_VECTOR (2 downto 0) := "000";
    constant ap_const_lv32_1F : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011111";
    constant ap_const_lv2_0 : STD_LOGIC_VECTOR (1 downto 0) := "00";
    constant ap_const_lv6_4 : STD_LOGIC_VECTOR (5 downto 0) := "000100";
    constant ap_const_lv32_1D : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011101";
    constant ap_const_lv32_1B : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011011";
    constant ap_const_lv32_1C : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011100";
    constant ap_const_lv32_1E : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011110";
    constant ap_const_boolean_0 : BOOLEAN := false;

    signal ap_CS_fsm : STD_LOGIC_VECTOR (7 downto 0) := "00000001";
    attribute fsm_encoding : string;
    attribute fsm_encoding of ap_CS_fsm : signal is "none";
    signal ap_CS_fsm_state1 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state1 : signal is "none";
    signal cacheMemory_address0 : STD_LOGIC_VECTOR (2 downto 0);
    signal cacheMemory_ce0 : STD_LOGIC;
    signal cacheMemory_we0 : STD_LOGIC_VECTOR (7 downto 0);
    signal cacheMemory_d0 : STD_LOGIC_VECTOR (63 downto 0);
    signal cacheMemory_q0 : STD_LOGIC_VECTOR (63 downto 0);
    signal updateDataValid_read_read_fu_110_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal updateTagValid_read_read_fu_116_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln7_fu_207_p1 : STD_LOGIC_VECTOR (26 downto 0);
    signal trunc_ln7_reg_445 : STD_LOGIC_VECTOR (26 downto 0);
    signal add_ln9_fu_235_p2 : STD_LOGIC_VECTOR (5 downto 0);
    signal add_ln9_reg_450 : STD_LOGIC_VECTOR (5 downto 0);
    signal cacheMemory_addr_reg_455 : STD_LOGIC_VECTOR (2 downto 0);
    signal or_ln11_fu_285_p2 : STD_LOGIC_VECTOR (5 downto 0);
    signal or_ln11_reg_460 : STD_LOGIC_VECTOR (5 downto 0);
    signal ap_CS_fsm_state3 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state3 : signal is "none";
    signal tmp_fu_297_p2 : STD_LOGIC_VECTOR (2 downto 0);
    signal tmp_reg_465 : STD_LOGIC_VECTOR (2 downto 0);
    signal ap_CS_fsm_state4 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state4 : signal is "none";
    signal trunc_ln15_1_fu_303_p1 : STD_LOGIC_VECTOR (26 downto 0);
    signal trunc_ln15_1_reg_470 : STD_LOGIC_VECTOR (26 downto 0);
    signal cacheMemory_addr_1_reg_475 : STD_LOGIC_VECTOR (2 downto 0);
    signal ap_CS_fsm_state5 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state5 : signal is "none";
    signal ap_CS_fsm_state7 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state7 : signal is "none";
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_idle : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0 : STD_LOGIC_VECTOR (1 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0 : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0 : STD_LOGIC_VECTOR (2 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0 : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0 : STD_LOGIC_VECTOR (7 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0 : STD_LOGIC_VECTOR (63 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg : STD_LOGIC := '0';
    signal zext_ln9_fu_251_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal zext_ln15_fu_306_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal idxprom48_fu_349_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_CS_fsm_state8 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state8 : signal is "none";
    signal icmp_ln21_fu_368_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln21_fu_354_p1 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_CS_fsm_state2 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state2 : signal is "none";
    signal zext_ln10_fu_280_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_CS_fsm_state6 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state6 : signal is "none";
    signal zext_ln17_fu_335_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal trunc_ln9_fu_211_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal trunc_ln9_1_fu_223_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal shl_ln9_1_fu_227_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal shl_ln9_fu_215_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal lshr_ln9_fu_241_p4 : STD_LOGIC_VECTOR (2 downto 0);
    signal tmp_3_fu_256_p4 : STD_LOGIC_VECTOR (29 downto 0);
    signal and_ln_fu_266_p3 : STD_LOGIC_VECTOR (31 downto 0);
    signal or_ln10_fu_274_p2 : STD_LOGIC_VECTOR (31 downto 0);
    signal empty_fu_294_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal trunc_ln15_fu_291_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal tmp_5_fu_310_p4 : STD_LOGIC_VECTOR (2 downto 0);
    signal tmp1_fu_320_p4 : STD_LOGIC_VECTOR (31 downto 0);
    signal or_ln16_fu_329_p2 : STD_LOGIC_VECTOR (31 downto 0);
    signal bf_lshr_cast_fu_340_p4 : STD_LOGIC_VECTOR (2 downto 0);
    signal trunc_ln21_3_fu_358_p4 : STD_LOGIC_VECTOR (26 downto 0);
    signal tmp_6_fu_373_p4 : STD_LOGIC_VECTOR (1 downto 0);
    signal zext_ln23_cast_fu_382_p4 : STD_LOGIC_VECTOR (5 downto 0);
    signal zext_ln23_fu_392_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal lshr_ln23_fu_396_p2 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_NS_fsm : STD_LOGIC_VECTOR (7 downto 0);
    signal ap_ST_fsm_state1_blk : STD_LOGIC;
    signal ap_ST_fsm_state2_blk : STD_LOGIC;
    signal ap_ST_fsm_state3_blk : STD_LOGIC;
    signal ap_block_state4_on_subcall_done : BOOLEAN;
    signal ap_ST_fsm_state4_blk : STD_LOGIC;
    signal ap_ST_fsm_state5_blk : STD_LOGIC;
    signal ap_ST_fsm_state6_blk : STD_LOGIC;
    signal ap_ST_fsm_state7_blk : STD_LOGIC;
    signal ap_ST_fsm_state8_blk : STD_LOGIC;
    signal ap_ce_reg : STD_LOGIC;

    component cache_module_cache_module_Pipeline_VITIS_LOOP_11_1 IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        newData_address0 : OUT STD_LOGIC_VECTOR (1 downto 0);
        newData_ce0 : OUT STD_LOGIC;
        newData_q0 : IN STD_LOGIC_VECTOR (7 downto 0);
        or_ln11 : IN STD_LOGIC_VECTOR (5 downto 0);
        cacheMemory_address0 : OUT STD_LOGIC_VECTOR (2 downto 0);
        cacheMemory_ce0 : OUT STD_LOGIC;
        cacheMemory_we0 : OUT STD_LOGIC_VECTOR (7 downto 0);
        cacheMemory_d0 : OUT STD_LOGIC_VECTOR (63 downto 0) );
    end component;


    component cache_module_cacheMemory_RAM_AUTO_1R1W IS
    generic (
        DataWidth : INTEGER;
        AddressRange : INTEGER;
        AddressWidth : INTEGER );
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        address0 : IN STD_LOGIC_VECTOR (2 downto 0);
        ce0 : IN STD_LOGIC;
        we0 : IN STD_LOGIC_VECTOR (7 downto 0);
        d0 : IN STD_LOGIC_VECTOR (63 downto 0);
        q0 : OUT STD_LOGIC_VECTOR (63 downto 0) );
    end component;



begin
    cacheMemory_U : component cache_module_cacheMemory_RAM_AUTO_1R1W
    generic map (
        DataWidth => 64,
        AddressRange => 8,
        AddressWidth => 3)
    port map (
        clk => ap_clk,
        reset => ap_rst,
        address0 => cacheMemory_address0,
        ce0 => cacheMemory_ce0,
        we0 => cacheMemory_we0,
        d0 => cacheMemory_d0,
        q0 => cacheMemory_q0);

    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198 : component cache_module_cache_module_Pipeline_VITIS_LOOP_11_1
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst,
        ap_start => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start,
        ap_done => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done,
        ap_idle => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_idle,
        ap_ready => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready,
        newData_address0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0,
        newData_ce0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0,
        newData_q0 => newData_q0,
        or_ln11 => or_ln11_reg_460,
        cacheMemory_address0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0,
        cacheMemory_ce0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0,
        cacheMemory_we0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0,
        cacheMemory_d0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0);





    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_fsm_state1;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;


    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_CS_fsm_state3)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= ap_const_logic_1;
                elsif ((grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready = ap_const_logic_1)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= ap_const_logic_0;
                end if; 
            end if;
        end if;
    end process;

    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state1))) then
                    add_ln9_reg_450(5 downto 3) <= add_ln9_fu_235_p2(5 downto 3);
                cacheMemory_addr_reg_455 <= zext_ln9_fu_251_p1(3 - 1 downto 0);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state5)) then
                cacheMemory_addr_1_reg_475 <= zext_ln15_fu_306_p1(3 - 1 downto 0);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state3)) then
                    or_ln11_reg_460(5 downto 3) <= or_ln11_fu_285_p2(5 downto 3);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((updateTagValid_read_read_fu_116_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                tmp_reg_465 <= tmp_fu_297_p2;
                trunc_ln15_1_reg_470 <= trunc_ln15_1_fu_303_p1;
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state1)) then
                trunc_ln7_reg_445 <= trunc_ln7_fu_207_p1;
            end if;
        end if;
    end process;
    add_ln9_reg_450(2 downto 0) <= "000";
    or_ln11_reg_460(2 downto 0) <= "100";

    ap_NS_fsm_assign_proc : process (ap_start, ap_CS_fsm, ap_CS_fsm_state1, updateDataValid_read_read_fu_110_p2, updateTagValid_read_read_fu_116_p2, ap_CS_fsm_state4, ap_block_state4_on_subcall_done)
    begin
        case ap_CS_fsm is
            when ap_ST_fsm_state1 => 
                if (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state4;
                elsif (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state2;
                else
                    ap_NS_fsm <= ap_ST_fsm_state1;
                end if;
            when ap_ST_fsm_state2 => 
                ap_NS_fsm <= ap_ST_fsm_state3;
            when ap_ST_fsm_state3 => 
                ap_NS_fsm <= ap_ST_fsm_state4;
            when ap_ST_fsm_state4 => 
                if (((updateTagValid_read_read_fu_116_p2 = ap_const_lv1_0) and (ap_const_boolean_0 = ap_block_state4_on_subcall_done) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                    ap_NS_fsm <= ap_ST_fsm_state6;
                elsif (((updateTagValid_read_read_fu_116_p2 = ap_const_lv1_1) and (ap_const_boolean_0 = ap_block_state4_on_subcall_done) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                    ap_NS_fsm <= ap_ST_fsm_state5;
                else
                    ap_NS_fsm <= ap_ST_fsm_state4;
                end if;
            when ap_ST_fsm_state5 => 
                ap_NS_fsm <= ap_ST_fsm_state6;
            when ap_ST_fsm_state6 => 
                ap_NS_fsm <= ap_ST_fsm_state7;
            when ap_ST_fsm_state7 => 
                ap_NS_fsm <= ap_ST_fsm_state8;
            when ap_ST_fsm_state8 => 
                ap_NS_fsm <= ap_ST_fsm_state1;
            when others =>  
                ap_NS_fsm <= "XXXXXXXX";
        end case;
    end process;
    add_ln9_fu_235_p2 <= std_logic_vector(unsigned(shl_ln9_1_fu_227_p3) + unsigned(shl_ln9_fu_215_p3));
    and_ln_fu_266_p3 <= (tmp_3_fu_256_p4 & ap_const_lv2_0);
    ap_CS_fsm_state1 <= ap_CS_fsm(0);
    ap_CS_fsm_state2 <= ap_CS_fsm(1);
    ap_CS_fsm_state3 <= ap_CS_fsm(2);
    ap_CS_fsm_state4 <= ap_CS_fsm(3);
    ap_CS_fsm_state5 <= ap_CS_fsm(4);
    ap_CS_fsm_state6 <= ap_CS_fsm(5);
    ap_CS_fsm_state7 <= ap_CS_fsm(6);
    ap_CS_fsm_state8 <= ap_CS_fsm(7);

    ap_ST_fsm_state1_blk_assign_proc : process(ap_start)
    begin
        if ((ap_start = ap_const_logic_0)) then 
            ap_ST_fsm_state1_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state1_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state2_blk <= ap_const_logic_0;
    ap_ST_fsm_state3_blk <= ap_const_logic_0;

    ap_ST_fsm_state4_blk_assign_proc : process(ap_block_state4_on_subcall_done)
    begin
        if ((ap_const_boolean_1 = ap_block_state4_on_subcall_done)) then 
            ap_ST_fsm_state4_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state4_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state5_blk <= ap_const_logic_0;
    ap_ST_fsm_state6_blk <= ap_const_logic_0;
    ap_ST_fsm_state7_blk <= ap_const_logic_0;
    ap_ST_fsm_state8_blk <= ap_const_logic_0;

    ap_block_state4_on_subcall_done_assign_proc : process(updateDataValid_read_read_fu_110_p2, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done)
    begin
                ap_block_state4_on_subcall_done <= ((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done = ap_const_logic_0));
    end process;


    ap_done_assign_proc : process(ap_CS_fsm_state8)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state8)) then 
            ap_done <= ap_const_logic_1;
        else 
            ap_done <= ap_const_logic_0;
        end if; 
    end process;


    ap_idle_assign_proc : process(ap_start, ap_CS_fsm_state1)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_0))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;


    ap_ready_assign_proc : process(ap_CS_fsm_state8)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state8)) then 
            ap_ready <= ap_const_logic_1;
        else 
            ap_ready <= ap_const_logic_0;
        end if; 
    end process;

    bf_lshr_cast_fu_340_p4 <= address(29 downto 27);

    cacheMemory_address0_assign_proc : process(ap_CS_fsm_state1, updateDataValid_read_read_fu_110_p2, cacheMemory_addr_reg_455, ap_CS_fsm_state4, cacheMemory_addr_1_reg_475, ap_CS_fsm_state5, ap_CS_fsm_state7, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0, zext_ln9_fu_251_p1, zext_ln15_fu_306_p1, idxprom48_fu_349_p1, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state7)) then 
            cacheMemory_address0 <= idxprom48_fu_349_p1(3 - 1 downto 0);
        elsif ((ap_const_logic_1 = ap_CS_fsm_state6)) then 
            cacheMemory_address0 <= cacheMemory_addr_1_reg_475;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state5)) then 
            cacheMemory_address0 <= zext_ln15_fu_306_p1(3 - 1 downto 0);
        elsif ((ap_const_logic_1 = ap_CS_fsm_state2)) then 
            cacheMemory_address0 <= cacheMemory_addr_reg_455;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state1)) then 
            cacheMemory_address0 <= zext_ln9_fu_251_p1(3 - 1 downto 0);
        elsif (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_address0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0;
        else 
            cacheMemory_address0 <= "XXX";
        end if; 
    end process;


    cacheMemory_ce0_assign_proc : process(ap_start, ap_CS_fsm_state1, updateDataValid_read_read_fu_110_p2, ap_CS_fsm_state4, ap_CS_fsm_state5, ap_CS_fsm_state7, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state6) or (ap_const_logic_1 = ap_CS_fsm_state2) or (ap_const_logic_1 = ap_CS_fsm_state7) or (ap_const_logic_1 = ap_CS_fsm_state5) or ((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1)))) then 
            cacheMemory_ce0 <= ap_const_logic_1;
        elsif (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_ce0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0;
        else 
            cacheMemory_ce0 <= ap_const_logic_0;
        end if; 
    end process;


    cacheMemory_d0_assign_proc : process(updateDataValid_read_read_fu_110_p2, ap_CS_fsm_state4, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0, ap_CS_fsm_state2, zext_ln10_fu_280_p1, ap_CS_fsm_state6, zext_ln17_fu_335_p1)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state6)) then 
            cacheMemory_d0 <= zext_ln17_fu_335_p1;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state2)) then 
            cacheMemory_d0 <= zext_ln10_fu_280_p1;
        elsif (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_d0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0;
        else 
            cacheMemory_d0 <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
        end if; 
    end process;


    cacheMemory_we0_assign_proc : process(updateDataValid_read_read_fu_110_p2, updateTagValid_read_read_fu_116_p2, ap_CS_fsm_state4, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state2) or ((updateTagValid_read_read_fu_116_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state6)))) then 
            cacheMemory_we0 <= ap_const_lv8_F;
        elsif (((updateDataValid_read_read_fu_110_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_we0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0;
        else 
            cacheMemory_we0 <= ap_const_lv8_0;
        end if; 
    end process;

    data <= lshr_ln23_fu_396_p2(8 - 1 downto 0);

    data_ap_vld_assign_proc : process(ap_CS_fsm_state8, icmp_ln21_fu_368_p2, trunc_ln21_fu_354_p1)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state8) and (trunc_ln21_fu_354_p1 = ap_const_lv1_1) and (icmp_ln21_fu_368_p2 = ap_const_lv1_1))) then 
            data_ap_vld <= ap_const_logic_1;
        else 
            data_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    dirty <= cacheMemory_q0(1);

    dirty_ap_vld_assign_proc : process(ap_CS_fsm_state8, icmp_ln21_fu_368_p2, trunc_ln21_fu_354_p1)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state8) and (trunc_ln21_fu_354_p1 = ap_const_lv1_1) and (icmp_ln21_fu_368_p2 = ap_const_lv1_1))) then 
            dirty_ap_vld <= ap_const_logic_1;
        else 
            dirty_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    empty_fu_294_p1 <= updateWay(3 - 1 downto 0);
    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg;

    hit_assign_proc : process(ap_CS_fsm_state8, icmp_ln21_fu_368_p2, trunc_ln21_fu_354_p1)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state8)) then
            if (((trunc_ln21_fu_354_p1 = ap_const_lv1_1) and (icmp_ln21_fu_368_p2 = ap_const_lv1_1))) then 
                hit <= ap_const_logic_1;
            elsif (((trunc_ln21_fu_354_p1 = ap_const_lv1_0) or (icmp_ln21_fu_368_p2 = ap_const_lv1_0))) then 
                hit <= ap_const_logic_0;
            else 
                hit <= 'X';
            end if;
        else 
            hit <= 'X';
        end if; 
    end process;


    hit_ap_vld_assign_proc : process(ap_CS_fsm_state8, icmp_ln21_fu_368_p2, trunc_ln21_fu_354_p1)
    begin
        if ((((ap_const_logic_1 = ap_CS_fsm_state8) and (trunc_ln21_fu_354_p1 = ap_const_lv1_1) and (icmp_ln21_fu_368_p2 = ap_const_lv1_1)) or ((ap_const_logic_1 = ap_CS_fsm_state8) and ((trunc_ln21_fu_354_p1 = ap_const_lv1_0) or (icmp_ln21_fu_368_p2 = ap_const_lv1_0))))) then 
            hit_ap_vld <= ap_const_logic_1;
        else 
            hit_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    icmp_ln21_fu_368_p2 <= "1" when (trunc_ln21_3_fu_358_p4 = trunc_ln7_reg_445) else "0";
    idxprom48_fu_349_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(bf_lshr_cast_fu_340_p4),64));
    lshr_ln23_fu_396_p2 <= std_logic_vector(shift_right(unsigned(cacheMemory_q0),to_integer(unsigned('0' & zext_ln23_fu_392_p1(31-1 downto 0)))));
    lshr_ln9_fu_241_p4 <= add_ln9_fu_235_p2(5 downto 3);
    newData_address0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0;
    newData_ce0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0;
    or_ln10_fu_274_p2 <= (ap_const_lv32_1 or and_ln_fu_266_p3);
    or_ln11_fu_285_p2 <= (ap_const_lv6_4 or add_ln9_reg_450);
    or_ln16_fu_329_p2 <= (tmp1_fu_320_p4 or ap_const_lv32_1);
    shl_ln9_1_fu_227_p3 <= (trunc_ln9_1_fu_223_p1 & ap_const_lv3_0);
    shl_ln9_fu_215_p3 <= (trunc_ln9_fu_211_p1 & ap_const_lv3_0);
    tmp1_fu_320_p4 <= ((tmp_5_fu_310_p4 & trunc_ln15_1_reg_470) & ap_const_lv2_0);
    tmp_3_fu_256_p4 <= cacheMemory_q0(31 downto 2);
    tmp_5_fu_310_p4 <= cacheMemory_q0(31 downto 29);
    tmp_6_fu_373_p4 <= address(31 downto 30);
    tmp_fu_297_p2 <= std_logic_vector(unsigned(empty_fu_294_p1) + unsigned(trunc_ln15_fu_291_p1));
    trunc_ln15_1_fu_303_p1 <= newTag(27 - 1 downto 0);
    trunc_ln15_fu_291_p1 <= updateSet(3 - 1 downto 0);
    trunc_ln21_3_fu_358_p4 <= cacheMemory_q0(28 downto 2);
    trunc_ln21_fu_354_p1 <= cacheMemory_q0(1 - 1 downto 0);
    trunc_ln7_fu_207_p1 <= address(27 - 1 downto 0);
    trunc_ln9_1_fu_223_p1 <= updateWay(3 - 1 downto 0);
    trunc_ln9_fu_211_p1 <= updateSet(3 - 1 downto 0);
    updateDataValid_read_read_fu_110_p2 <= (0=>updateDataValid, others=>'-');
    updateTagValid_read_read_fu_116_p2 <= (0=>updateTagValid, others=>'-');
    zext_ln10_fu_280_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(or_ln10_fu_274_p2),64));
    zext_ln15_fu_306_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(tmp_reg_465),64));
    zext_ln17_fu_335_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(or_ln16_fu_329_p2),64));
    zext_ln23_cast_fu_382_p4 <= ((ap_const_lv1_1 & tmp_6_fu_373_p4) & ap_const_lv3_0);
    zext_ln23_fu_392_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(zext_ln23_cast_fu_382_p4),64));
    zext_ln9_fu_251_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(lshr_ln9_fu_241_p4),64));
end behav;
